package org.jomc.mojo;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.maven.plugin.AbstractMojo;
import org.apache.maven.plugin.MojoExecutionException;

/**
 * Display help information on maven-jomc-plugin.<br/> Call <pre>  mvn jomc:help -Ddetail=true -Dgoal=&lt;goal-name&gt;</pre> to display parameter details.
 *
 * @version generated on Wed Jan 02 16:42:39 CET 2013
 * @author org.apache.maven.tools.plugin.generator.PluginHelpGenerator (version 2.9)
 * @goal help
 * @requiresProject false
 * @threadSafe
 */
@SuppressWarnings( "all" )
public class HelpMojo
    extends AbstractMojo
{
    /**
     * If <code>true</code>, display all settable properties for each goal.
     * 
     * @parameter expression="${detail}" default-value="false"
     */
    private boolean detail;

    /**
     * The name of the goal for which to show help. If unspecified, all goals will be displayed.
     * 
     * @parameter expression="${goal}"
     */
    private java.lang.String goal;

    /**
     * The maximum length of a display line, should be positive.
     * 
     * @parameter expression="${lineLength}" default-value="80"
     */
    private int lineLength;

    /**
     * The number of spaces per indentation level, should be positive.
     * 
     * @parameter expression="${indentSize}" default-value="2"
     */
    private int indentSize;


    /** {@inheritDoc} */
    public void execute()
        throws MojoExecutionException
    {
        if ( lineLength <= 0 )
        {
            getLog().warn( "The parameter 'lineLength' should be positive, using '80' as default." );
            lineLength = 80;
        }
        if ( indentSize <= 0 )
        {
            getLog().warn( "The parameter 'indentSize' should be positive, using '2' as default." );
            indentSize = 2;
        }

        StringBuffer sb = new StringBuffer();

        append( sb, "org.jomc:maven-jomc-plugin:1.4", 0 );
        append( sb, "", 0 );

        append( sb, "JOMC \u2051 Maven Plugin", 0 );
        append( sb, "Object management and configuration tools for Apache Maven.", 1 );
        append( sb, "", 0 );

        if ( goal == null || goal.length() <= 0 )
        {
            append( sb, "This plugin has 21 goals:", 0 );
            append( sb, "", 0 );
        }

        if ( goal == null || goal.length() <= 0 || "attach-main-module".equals( goal ) )
        {
            append( sb, "jomc:attach-main-module", 0 );
            append( sb, "Attaches a project\'s main module artifact.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "attachMainModuleExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.attachMainModuleExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "mainModuleArtifactClassifier (Default: jomc-module)", 2 );
                append( sb, "Classifier of the attached module artifact.", 3 );
                append( sb, "Expression: ${jomc.mainModuleArtifactClassifier}", 3 );
                append( sb, "", 0 );

                append( sb, "mainModuleArtifactFile (Default: ${project.build.outputDirectory}/META-INF/jomc.xml)", 2 );
                append( sb, "File of the attached module artifact.", 3 );
                append( sb, "Expression: ${jomc.mainModuleArtifactFile}", 3 );
                append( sb, "", 0 );

                append( sb, "mainModuleArtifactType (Default: xml)", 2 );
                append( sb, "Type of the attached module artifact.", 3 );
                append( sb, "Expression: ${jomc.mainModuleArtifactType}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "attach-test-module".equals( goal ) )
        {
            append( sb, "jomc:attach-test-module", 0 );
            append( sb, "Attaches a project\'s test module artifact.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "attachTestModuleExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.attachTestModuleExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleArtifactClassifier (Default: jomc-test-module)", 2 );
                append( sb, "Classifier of the attached module artifact.", 3 );
                append( sb, "Expression: ${jomc.testModuleArtifactClassifier}", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleArtifactFile (Default: ${project.build.testOutputDirectory}/META-INF/jomc.xml)", 2 );
                append( sb, "File of the attached module artifact.", 3 );
                append( sb, "Expression: ${jomc.testModuleArtifactFile}", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleArtifactType (Default: xml)", 2 );
                append( sb, "Type of the attached module artifact.", 3 );
                append( sb, "Expression: ${jomc.testModuleArtifactType}", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "commit-main-classes".equals( goal ) )
        {
            append( sb, "jomc:commit-main-classes", 0 );
            append( sb, "Commits model objects to a projects\' main classes.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "commitMainClassesExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.commitMainClassesExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectStylesheet", 2 );
                append( sb, "XSLT document to use for transforming model objects.\nThe value of the parameter is a location to search a XSLT document at. First the value is used to search the class path of the plugin. If a class path resource is found, a XSLT document is loaded from that resource. If no class path resource is found, an attempt is made to parse the value to an URL. Succeeding that, an XSLT document is loaded from that URL (since version 1.2). Failing that, the value is interpreted as a file name of a XSLT document to load relative to the base directory of the project. If that file exists, a XSLT document is loaded from that file. If no XSLT document is found at the given location, a build failure is produced.\n\nNote: When upgrading to version 1.2, any project dependencies holding XSLT documents referenced by this parameter need to be added to the plugins\' dependencies.\n\nDeprecated: As of JOMC 1.2, please use the \'modelObjectStylesheetResources\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectStylesheetResources", 2 );
                append( sb, "XSLT documents to use for transforming model objects.\n<modelObjectStylesheetResources>\n\u00a0\u00a0<modelObjectStylesheetResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0XSLT\u00a0document.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0XSLT\u00a0document\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0\u00a0\u00a0<transformationParameterResources>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0</transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0</transformationParameterResources>\n\u00a0\u00a0\u00a0\u00a0<transformationParameters>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0</transformationParameter>\n\u00a0\u00a0\u00a0\u00a0</transformationParameters>\n\u00a0\u00a0\u00a0\u00a0<transformationOutputProperties>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0</transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0</transformationOutputProperties>\n\u00a0\u00a0</modelObjectStylesheetResource>\n</modelObjectStylesheetResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "commit-test-classes".equals( goal ) )
        {
            append( sb, "jomc:commit-test-classes", 0 );
            append( sb, "Commits model objects to a projects\' test classes.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "commitTestClassesExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.commitTestClassesExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectStylesheet", 2 );
                append( sb, "XSLT document to use for transforming model objects.\nThe value of the parameter is a location to search a XSLT document at. First the value is used to search the class path of the plugin. If a class path resource is found, a XSLT document is loaded from that resource. If no class path resource is found, an attempt is made to parse the value to an URL. Succeeding that, an XSLT document is loaded from that URL (since version 1.2). Failing that, the value is interpreted as a file name of a XSLT document to load relative to the base directory of the project. If that file exists, a XSLT document is loaded from that file. If no XSLT document is found at the given location, a build failure is produced.\n\nNote: When upgrading to version 1.2, any project dependencies holding XSLT documents referenced by this parameter need to be added to the plugins\' dependencies.\n\nDeprecated: As of JOMC 1.2, please use the \'modelObjectStylesheetResources\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectStylesheetResources", 2 );
                append( sb, "XSLT documents to use for transforming model objects.\n<modelObjectStylesheetResources>\n\u00a0\u00a0<modelObjectStylesheetResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0XSLT\u00a0document.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0XSLT\u00a0document\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0\u00a0\u00a0<transformationParameterResources>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0</transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0</transformationParameterResources>\n\u00a0\u00a0\u00a0\u00a0<transformationParameters>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0</transformationParameter>\n\u00a0\u00a0\u00a0\u00a0</transformationParameters>\n\u00a0\u00a0\u00a0\u00a0<transformationOutputProperties>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0\u00a0\u00a0\u00a0\u00a0</transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0</transformationOutputProperties>\n\u00a0\u00a0</modelObjectStylesheetResource>\n</modelObjectStylesheetResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "help".equals( goal ) )
        {
            append( sb, "jomc:help", 0 );
            append( sb, "Display help information on maven-jomc-plugin.\nCall\n\u00a0\u00a0mvn\u00a0jomc:help\u00a0-Ddetail=true\u00a0-Dgoal=<goal-name>\nto display parameter details.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "detail (Default: false)", 2 );
                append( sb, "If true, display all settable properties for each goal.", 3 );
                append( sb, "Expression: ${detail}", 3 );
                append( sb, "", 0 );

                append( sb, "goal", 2 );
                append( sb, "The name of the goal for which to show help. If unspecified, all goals will be displayed.", 3 );
                append( sb, "Expression: ${goal}", 3 );
                append( sb, "", 0 );

                append( sb, "indentSize (Default: 2)", 2 );
                append( sb, "The number of spaces per indentation level, should be positive.", 3 );
                append( sb, "Expression: ${indentSize}", 3 );
                append( sb, "", 0 );

                append( sb, "lineLength (Default: 80)", 2 );
                append( sb, "The maximum length of a display line, should be positive.", 3 );
                append( sb, "Expression: ${lineLength}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "manage-main-sources".equals( goal ) )
        {
            append( sb, "jomc:manage-main-sources", 0 );
            append( sb, "Manages a projects\' main source files.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "manageMainSourcesExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.manageMainSourcesExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "manage-test-sources".equals( goal ) )
        {
            append( sb, "jomc:manage-test-sources", 0 );
            append( sb, "Manages a projects\' test source files.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "manageTestSourcesExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.manageTestSourcesExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "show-main-instance".equals( goal ) )
        {
            append( sb, "jomc:show-main-instance", 0 );
            append( sb, "Displays a project\'s main instance.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "document", 2 );
                append( sb, "File to write the model to.", 3 );
                append( sb, "Expression: ${jomc.document}", 3 );
                append( sb, "", 0 );

                append( sb, "documentEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "Encoding of the document to write.", 3 );
                append( sb, "Expression: ${jomc.documentEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "identifier", 2 );
                append( sb, "Identifier of the instance to show.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${jomc.identifier}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showMainInstanceExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.showMainInstanceExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "show-main-model".equals( goal ) )
        {
            append( sb, "jomc:show-main-model", 0 );
            append( sb, "Displays a project\'s main model.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "document", 2 );
                append( sb, "File to write the model to.", 3 );
                append( sb, "Expression: ${jomc.document}", 3 );
                append( sb, "", 0 );

                append( sb, "documentEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "Encoding of the document to write.", 3 );
                append( sb, "Expression: ${jomc.documentEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showMainModelExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.showMainModelExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "show-main-specification".equals( goal ) )
        {
            append( sb, "jomc:show-main-specification", 0 );
            append( sb, "Displays a project\'s main specification.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "document", 2 );
                append( sb, "File to write the model to.", 3 );
                append( sb, "Expression: ${jomc.document}", 3 );
                append( sb, "", 0 );

                append( sb, "documentEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "Encoding of the document to write.", 3 );
                append( sb, "Expression: ${jomc.documentEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "identifier", 2 );
                append( sb, "Identifier of the specification to show.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${jomc.identifier}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showMainSpecificationExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.showMainSpecificationExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "show-test-instance".equals( goal ) )
        {
            append( sb, "jomc:show-test-instance", 0 );
            append( sb, "Displays a project\'s test instance.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "document", 2 );
                append( sb, "File to write the model to.", 3 );
                append( sb, "Expression: ${jomc.document}", 3 );
                append( sb, "", 0 );

                append( sb, "documentEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "Encoding of the document to write.", 3 );
                append( sb, "Expression: ${jomc.documentEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "identifier", 2 );
                append( sb, "Identifier of the instance to show.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${jomc.identifier}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showTestInstanceExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.showTestInstanceExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "show-test-model".equals( goal ) )
        {
            append( sb, "jomc:show-test-model", 0 );
            append( sb, "Displays a project\'s test model.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "document", 2 );
                append( sb, "File to write the model to.", 3 );
                append( sb, "Expression: ${jomc.document}", 3 );
                append( sb, "", 0 );

                append( sb, "documentEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "Encoding of the document to write.", 3 );
                append( sb, "Expression: ${jomc.documentEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showTestModelExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.showTestModelExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "show-test-specification".equals( goal ) )
        {
            append( sb, "jomc:show-test-specification", 0 );
            append( sb, "Displays a project\'s test specification.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "document", 2 );
                append( sb, "File to write the model to.", 3 );
                append( sb, "Expression: ${jomc.document}", 3 );
                append( sb, "", 0 );

                append( sb, "documentEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "Encoding of the document to write.", 3 );
                append( sb, "Expression: ${jomc.documentEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "identifier", 2 );
                append( sb, "Identifier of the specification to show.", 3 );
                append( sb, "Required: Yes", 3 );
                append( sb, "Expression: ${jomc.identifier}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "showTestSpecificationExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.showTestSpecificationExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "validate-main-classes".equals( goal ) )
        {
            append( sb, "jomc:validate-main-classes", 0 );
            append( sb, "Validates a projects\' main class file model objects.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "validateMainClassesExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.validateMainClassesExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "validate-main-classpath".equals( goal ) )
        {
            append( sb, "jomc:validate-main-classpath", 0 );
            append( sb, "Validates a projects\' main classpath class file model objects.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "validateMainClasspathExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.validateMainClasspathExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "validate-main-model".equals( goal ) )
        {
            append( sb, "jomc:validate-main-model", 0 );
            append( sb, "Validates a project\'s main model.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "validateMainModelExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.validateMainModelExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "validate-test-classes".equals( goal ) )
        {
            append( sb, "jomc:validate-test-classes", 0 );
            append( sb, "Validates a projects\' test class file model objects.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "validateTestClassesExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.validateTestClassesExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "validate-test-classpath".equals( goal ) )
        {
            append( sb, "jomc:validate-test-classpath", 0 );
            append( sb, "Validates a projects\' test class path class file model objects.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "validateTestClasspathExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.validateTestClasspathExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "validate-test-model".equals( goal ) )
        {
            append( sb, "jomc:validate-test-model", 0 );
            append( sb, "Validates a project\'s test model.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "validateTestModelExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.validateTestModelExecutionStrategy}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "write-main-resources".equals( goal ) )
        {
            append( sb, "jomc:write-main-resources", 0 );
            append( sb, "Writes a projects\' main resource files.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "mainResourcesOutputDirectory (Default: ${project.build.directory}/generated-resources/jomc)", 2 );
                append( sb, "Directory to write resource files to.", 3 );
                append( sb, "Expression: ${jomc.mainResourcesOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceBundleDefaultLanguage", 2 );
                append( sb, "The language of the default language properties file of generated resource bundle properties resources.", 3 );
                append( sb, "Expression: ${jomc.resourceBundleDefaultLanguage}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "writeMainResourcesExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.writeMainResourcesExecutionStrategy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( goal == null || goal.length() <= 0 || "write-test-resources".equals( goal ) )
        {
            append( sb, "jomc:write-test-resources", 0 );
            append( sb, "Writes a projects\' test resource files.", 1 );
            append( sb, "", 0 );
            if ( detail )
            {
                append( sb, "Available parameters:", 1 );
                append( sb, "", 0 );

                append( sb, "classesDirectory", 2 );
                append( sb, "Directory holding the compiled class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'outputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "classFileProcessorClassName (Default: org.jomc.tools.ClassFileProcessor)", 2 );
                append( sb, "Class name of the ClassFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.classFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "classProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of class files.", 3 );
                append( sb, "Expression: ${jomc.classProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "defaultTemplateProfile", 2 );
                append( sb, "The default template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.defaultTemplateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "indentation", 2 );
                append( sb, "The indentation string (\'\\t\' for tab).", 3 );
                append( sb, "Expression: ${jomc.indentation}", 3 );
                append( sb, "", 0 );

                append( sb, "javaValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling Java validation.", 3 );
                append( sb, "Expression: ${jomc.javaValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "lineSeparator", 2 );
                append( sb, "The line separator (\'\\r\\n\' for DOS, \'\\r\' for Mac, \'\\n\' for Unix).", 3 );
                append( sb, "Expression: ${jomc.lineSeparator}", 3 );
                append( sb, "", 0 );

                append( sb, "locale", 2 );
                append( sb, "The locale.\n<locale>\n\u00a0\u00a0<language>Lowercase\u00a0two-letter\u00a0ISO-639\u00a0code.</language>\n\u00a0\u00a0<country>Uppercase\u00a0two-letter\u00a0ISO-3166\u00a0code.</country>\n\u00a0\u00a0<variant>Vendor\u00a0and\u00a0browser\u00a0specific\u00a0code.</variant>\n</locale>\n", 3 );
                append( sb, "", 0 );

                append( sb, "model (Default: http://jomc.org/model)", 2 );
                append( sb, "The identifier of the model to process.", 3 );
                append( sb, "Expression: ${jomc.model}", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextAttributes", 2 );
                append( sb, "ModelContext attributes.\n<modelContextAttributes>\n\u00a0\u00a0<modelContextAttribute>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0attribute.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0attribute.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0attributes\'s\u00a0object.</type>\n\u00a0\u00a0</modelContextAttribute>\n</modelContextAttributes>\n", 3 );
                append( sb, "", 0 );

                append( sb, "modelContextFactoryClassName", 2 );
                append( sb, "The name of the ModelContextFactory implementation class backing the task.", 3 );
                append( sb, "Expression: ${jomc.modelContextFactoryClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "modelObjectClasspathResolutionEnabled (Default: true)", 2 );
                append( sb, "Controls model object class path resolution.", 3 );
                append( sb, "Expression: ${jomc.modelObjectClasspathResolution}", 3 );
                append( sb, "", 0 );

                append( sb, "modelProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of models.", 3 );
                append( sb, "Expression: ${jomc.modelProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "modelResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of model resources.", 3 );
                append( sb, "Expression: ${jomc.modelResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletLocation", 2 );
                append( sb, "The location to search for modlets.", 3 );
                append( sb, "Expression: ${jomc.modletLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "modletResourceValidationEnabled (Default: true)", 2 );
                append( sb, "Flag controlling JAXP schema validation of modlet resources.", 3 );
                append( sb, "Expression: ${jomc.modletResourceValidationEnabled}", 3 );
                append( sb, "", 0 );

                append( sb, "modletSchemaSystemId", 2 );
                append( sb, "The http://jomc.org/modlet namespace schema system id.", 3 );
                append( sb, "Expression: ${jomc.modletSchemaSystemId}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleLocation", 2 );
                append( sb, "The location to search for modules.", 3 );
                append( sb, "Expression: ${jomc.moduleLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "moduleName (Default: ${project.name})", 2 );
                append( sb, "Name of the module to process.", 3 );
                append( sb, "Expression: ${jomc.moduleName}", 3 );
                append( sb, "", 0 );

                append( sb, "outputDirectory (Default: ${project.build.outputDirectory})", 2 );
                append( sb, "Output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.outputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "platformProviderLocation", 2 );
                append( sb, "The location to search for platform providers.", 3 );
                append( sb, "Expression: ${jomc.platformProviderLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "providerLocation", 2 );
                append( sb, "The location to search for providers.", 3 );
                append( sb, "Expression: ${jomc.providerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "reportOutputDirectory (Default: ${project.reporting.outputDirectory})", 2 );
                append( sb, "Directory holding the reports of the project.", 3 );
                append( sb, "Expression: ${jomc.reportOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceBundleDefaultLanguage", 2 );
                append( sb, "The language of the default language properties file of generated resource bundle properties resources.", 3 );
                append( sb, "Expression: ${jomc.resourceBundleDefaultLanguage}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceFileProcessorClassName (Default: org.jomc.tools.ResourceFileProcessor)", 2 );
                append( sb, "Class name of the ResourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.resourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "resourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of resource files.", 3 );
                append( sb, "Expression: ${jomc.resourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "sessionDirectory (Default: ${project.build.directory}/jomc-sessions)", 2 );
                append( sb, "Directory holding the session related files of the project.", 3 );
                append( sb, "Expression: ${jomc.sessionDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceDirectory (Default: ${project.build.sourceDirectory})", 2 );
                append( sb, "Directory holding the source files of the project.", 3 );
                append( sb, "Expression: ${jomc.sourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceEncoding (Default: ${project.build.sourceEncoding})", 2 );
                append( sb, "The encoding to use for reading and writing files.", 3 );
                append( sb, "Expression: ${jomc.sourceEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceFileProcessorClassName (Default: org.jomc.tools.SourceFileProcessor)", 2 );
                append( sb, "Class name of the SourceFileProcessor backing the goal.", 3 );
                append( sb, "Expression: ${jomc.sourceFileProcessorClassName}", 3 );
                append( sb, "", 0 );

                append( sb, "sourceProcessingEnabled (Default: true)", 2 );
                append( sb, "Controls processing of source code files.", 3 );
                append( sb, "Expression: ${jomc.sourceProcessing}", 3 );
                append( sb, "", 0 );

                append( sb, "templateEncoding", 2 );
                append( sb, "The encoding to use for reading templates.\nDeprecated: As of JOMC 1.3, please use the \'defaultTemplateEncoding\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "Expression: ${jomc.templateEncoding}", 3 );
                append( sb, "", 0 );

                append( sb, "templateLocation", 2 );
                append( sb, "Location to search for templates in addition to searching the class path of the plugin.\nFirst an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a directory name relative to the base directory of the project. If that directory exists, that directory is used. If nothing is found at the given location, a warning message is logged.\n", 3 );
                append( sb, "Expression: ${jomc.templateLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameterResources", 2 );
                append( sb, "Template parameter resources.\n<templateParameterResources>\n\u00a0\u00a0<templateParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</templateParameterResource>\n</templateParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateParameters", 2 );
                append( sb, "Template parameters.\n<templateParameters>\n\u00a0\u00a0<templateParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</templateParameter>\n</templateParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "templateProfile", 2 );
                append( sb, "The template profile to use when accessing templates.", 3 );
                append( sb, "Expression: ${jomc.templateProfile}", 3 );
                append( sb, "", 0 );

                append( sb, "testClassesDirectory", 2 );
                append( sb, "Directory holding the compiled test class files of the project.\nDeprecated: As of JOMC 1.1, please use the \'testOutputDirectory\' parameter. This parameter will be removed in version 2.0.\n", 3 );
                append( sb, "", 0 );

                append( sb, "testModuleName (Default: ${project.name} Tests)", 2 );
                append( sb, "Name of the test module to process.", 3 );
                append( sb, "Expression: ${jomc.testModuleName}", 3 );
                append( sb, "", 0 );

                append( sb, "testOutputDirectory (Default: ${project.build.testOutputDirectory})", 2 );
                append( sb, "Test output directory of the project.", 3 );
                append( sb, "Expression: ${jomc.testOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testResourcesOutputDirectory (Default: ${project.build.directory}/generated-test-resources/jomc)", 2 );
                append( sb, "Directory to write test resource files to.", 3 );
                append( sb, "Expression: ${jomc.testResourcesOutputDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "testSourceDirectory (Default: ${project.build.testSourceDirectory})", 2 );
                append( sb, "Directory holding the test source files of the project.", 3 );
                append( sb, "Expression: ${jomc.testSourceDirectory}", 3 );
                append( sb, "", 0 );

                append( sb, "transformationOutputProperties", 2 );
                append( sb, "Global transformation output properties.\n<transformationOutputProperties>\n\u00a0\u00a0<transformationOutputProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</transformationOutputProperty>\n</transformationOutputProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameterResources", 2 );
                append( sb, "Global transformation parameter resources.\n<transformationParameterResources>\n\u00a0\u00a0<transformationParameterResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</transformationParameterResource>\n</transformationParameterResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformationParameters", 2 );
                append( sb, "Global transformation parameters.\n<transformationParameters>\n\u00a0\u00a0<transformationParameter>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0parameter.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0parameter.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0parameter\'s\u00a0object.</type>\n\u00a0\u00a0</transformationParameter>\n</transformationParameters>\n", 3 );
                append( sb, "", 0 );

                append( sb, "transformerLocation", 2 );
                append( sb, "The location to search for transformers.", 3 );
                append( sb, "Expression: ${jomc.transformerLocation}", 3 );
                append( sb, "", 0 );

                append( sb, "velocityProperties", 2 );
                append( sb, "Velocity runtime properties.\n<velocityProperties>\n\u00a0\u00a0<velocityProperty>\n\u00a0\u00a0\u00a0\u00a0<key>The\u00a0name\u00a0of\u00a0the\u00a0property.</key>\n\u00a0\u00a0\u00a0\u00a0<value>The\u00a0value\u00a0of\u00a0the\u00a0property.</value>\n\u00a0\u00a0\u00a0\u00a0<type>The\u00a0name\u00a0of\u00a0the\u00a0class\u00a0of\u00a0the\u00a0properties\u00a0object.</type>\n\u00a0\u00a0</velocityProperty>\n</velocityProperties>\n", 3 );
                append( sb, "", 0 );

                append( sb, "velocityPropertyResources", 2 );
                append( sb, "Velocity runtime property resources.\n<velocityPropertyResources>\n\u00a0\u00a0<velocityPropertyResource>\n\u00a0\u00a0\u00a0\u00a0<location>The\u00a0location\u00a0of\u00a0the\u00a0properties\u00a0resource.</location>\n\u00a0\u00a0\u00a0\u00a0<optional>Flag\u00a0indicating\u00a0the\u00a0properties\u00a0resource\u00a0is\u00a0optional.</optional>\n\u00a0\u00a0\u00a0\u00a0<format>The\u00a0format\u00a0of\u00a0the\u00a0properties\u00a0resource.</format>\n\u00a0\u00a0\u00a0\u00a0<connectTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</connectTimeout>\n\u00a0\u00a0\u00a0\u00a0<readTimeout>Timeout\u00a0value,\u00a0in\u00a0milliseconds.</readTimeout>\n\u00a0\u00a0</velocityPropertyResource>\n</velocityPropertyResources>\n\nThe location value is used to first search the class path of the plugin. If a class path resource is found, that resource is used. If no class path resource is found, an attempt is made to parse the location value to an URL. On successful parsing, that URL is used. Otherwise the location value is interpreted as a file name relative to the base directory of the project. If that file exists, that file is used. If nothing is found at the given location, depending on the optional flag, a warning message is logged or a build failure is produced.\n\nThe optional flag is used to flag the resource optional. When an optional resource is not found, a warning message is logged instead of producing a build failure.\nDefault value is: false\n\nThe format value is used to specify the format of the properties resource. Supported values are plain and xml.\nDefault value is: plain\n\nThe connectTimeout value is used to specify the timeout, in milliseconds, to be used when opening communications links to the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n\nThe readTimeout value is used to specify the timeout, in milliseconds, to be used when reading the resource. A timeout of zero is interpreted as an infinite timeout.\nDefault value is: 60000\n", 3 );
                append( sb, "", 0 );

                append( sb, "verbose (Default: false)", 2 );
                append( sb, "Controls verbosity of the plugin.", 3 );
                append( sb, "Expression: ${jomc.verbose}", 3 );
                append( sb, "", 0 );

                append( sb, "writeTestResourcesExecutionStrategy (Default: once-per-session)", 2 );
                append( sb, "Execution strategy of the goal (always or once-per-session).", 3 );
                append( sb, "Expression: ${jomc.writeTestResourcesExecutionStrategy}", 3 );
                append( sb, "", 0 );
            }
        }

        if ( getLog().isInfoEnabled() )
        {
            getLog().info( sb.toString() );
        }
    }

    /**
     * <p>Repeat a String <code>n</code> times to form a new string.</p>
     *
     * @param str String to repeat
     * @param repeat number of times to repeat str
     * @return String with repeated String
     * @throws NegativeArraySizeException if <code>repeat < 0</code>
     * @throws NullPointerException if str is <code>null</code>
     */
    private static String repeat( String str, int repeat )
    {
        StringBuffer buffer = new StringBuffer( repeat * str.length() );

        for ( int i = 0; i < repeat; i++ )
        {
            buffer.append( str );
        }

        return buffer.toString();
    }

    /** 
     * Append a description to the buffer by respecting the indentSize and lineLength parameters.
     * <b>Note</b>: The last character is always a new line.
     * 
     * @param sb The buffer to append the description, not <code>null</code>.
     * @param description The description, not <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     */
    private void append( StringBuffer sb, String description, int indent )
    {
        for ( Iterator it = toLines( description, indent, indentSize, lineLength ).iterator(); it.hasNext(); )
        {
            sb.append( it.next().toString() ).append( '\n' );
        }
    }

    /** 
     * Splits the specified text into lines of convenient display length.
     * 
     * @param text The text to split into lines, must not be <code>null</code>.
     * @param indent The base indentation level of each line, must not be negative.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     * @return The sequence of display lines, never <code>null</code>.
     * @throws NegativeArraySizeException if <code>indent < 0</code>
     */
    private static List toLines( String text, int indent, int indentSize, int lineLength )
    {
        List<String> lines = new ArrayList<String>();

        String ind = repeat( "\t", indent );
        String[] plainLines = text.split( "(\r\n)|(\r)|(\n)" );
        for ( int i = 0; i < plainLines.length; i++ )
        {
            toLines( lines, ind + plainLines[i], indentSize, lineLength );
        }

        return lines;
    }

    /** 
     * Adds the specified line to the output sequence, performing line wrapping if necessary.
     * 
     * @param lines The sequence of display lines, must not be <code>null</code>.
     * @param line The line to add, must not be <code>null</code>.
     * @param indentSize The size of each indentation, must not be negative.
     * @param lineLength The length of the line, must not be negative.
     */
    private static void toLines( List<String> lines, String line, int indentSize, int lineLength )
    {
        int lineIndent = getIndentLevel( line );
        StringBuffer buf = new StringBuffer( 256 );
        String[] tokens = line.split( " +" );
        for ( int i = 0; i < tokens.length; i++ )
        {
            String token = tokens[i];
            if ( i > 0 )
            {
                if ( buf.length() + token.length() >= lineLength )
                {
                    lines.add( buf.toString() );
                    buf.setLength( 0 );
                    buf.append( repeat( " ", lineIndent * indentSize ) );
                }
                else
                {
                    buf.append( ' ' );
                }
            }
            for ( int j = 0; j < token.length(); j++ )
            {
                char c = token.charAt( j );
                if ( c == '\t' )
                {
                    buf.append( repeat( " ", indentSize - buf.length() % indentSize ) );
                }
                else if ( c == '\u00A0' )
                {
                    buf.append( ' ' );
                }
                else
                {
                    buf.append( c );
                }
            }
        }
        lines.add( buf.toString() );
    }

    /** 
     * Gets the indentation level of the specified line.
     * 
     * @param line The line whose indentation level should be retrieved, must not be <code>null</code>.
     * @return The indentation level of the line.
     */
    private static int getIndentLevel( String line )
    {
        int level = 0;
        for ( int i = 0; i < line.length() && line.charAt( i ) == '\t'; i++ )
        {
            level++;
        }
        for ( int i = level + 1; i <= level + 4 && i < line.length(); i++ )
        {
            if ( line.charAt( i ) == '\t' )
            {
                level++;
                break;
            }
        }
        return level;
    }
}
